<template>
  <q-form
    @submit="onSubmit"
    @reset="onReset"
    class="q-gutter-md"
  >
    <q-input
      standout="bg-green text-white"
      label="Judul"
      v-model="form.judul"
      hint="Barang/Jasa/Investor"
      :rules="[ val => val && val.length > 0 || 'Mohon Isi']"
    />
    <div class="row">
      <div class="col-md-6 col-xs-12" style="min-height: 100px;">
        <q-file label-color="green" counter outlined label="Gambar Banner" v-model="form.gambar" use-chips ref="mainImage"
                @input="mainImageUrlChange"
                accept="image/*" @clear="mainImageUrlChange">
          <template v-slot:prepend>
            <q-icon name="attach_file" />
          </template>
          <template v-slot:hint>
            <ul>
              <li>Format gambar yang diijinkan adalah jpg, jpeg & png.</li>
              <li>Maksimal Ukuran Gambar adalah 2 mb.</li>
            </ul>
          </template>
        </q-file>
      </div>
      <div class="col-md-6 col-xs-12" >
        <q-img style="height: 300px" :src="mainImageUrl" v-if="mainImageUrl" >
          <div class="absolute-bottom-right text-subtitle2">
            <q-btn icon="delete" color="red" @click="deleteMainImage" />
          </div>
        </q-img>
      </div>
    </div>
    <q-input
      standout="bg-green text-white"
      label="Deskripsi"
      v-model="form.description"
      type="textarea"
      :rules="[ val => val && val.length > 0 || 'Mohon Isi']"
    />
    <q-input
      standout="bg-green text-white"
      label="Target URL"
      hint="Barang/Jasa/Investor"
      v-model="form.target_url"
      :rules="[ val => val && val.length > 0 || 'Mohon Isi']"
    />
    <div class="row">
      <div class="col-md-1 col-xs-12" style="max" >
        <p style="margin: 13px 50px 0 0; font-size: 20px">Status</p>
        <q-toggle
          v-model="form.status"
          :true-value="1"
          :false-value="0"
          :label="form.status == 0 ? `Unpublish` : `Publish` "
        />
      </div>
      <div class="col-md-6 col-xs-12" >
        <div class="column">
          <p style="margin: 13px 50px 0 0; font-size: 20px">Masa Berlaku</p>
          <q-date v-model="form.masaberlaku" range />
        </div>
      </div>
    </div>
    <div>
      <q-btn label="Simpan Banner" type="submit" color="green"/>
    </div>
  </q-form>
</template>

<script>
export default {
  name: 'FormBanner',
  data () {
    return {
      form: {
        judul: null,
        description: null,
        target_url: null,
        gambar: null,
        status: 1,
        masaberlaku: null,
        start: null,
        end: null
      },
      mainImageUrl: null
    }
  },
  beforeMount() {
    if (this.$attrs) {
      let dataBanner = this.$attrs.dataBanner
      this.form.judul = dataBanner.judul
      this.mainImageUrl = dataBanner.gambar
      this.form.description = dataBanner.description
      this.form.target_url = dataBanner.target_url
      this.form.masaberlaku = {
        from: dataBanner.start,
        to: dataBanner.end
      }
    }
  },
  methods: {
    deleteMainImage() {
      this.$refs.mainImage.removeAtIndex(0);
    },
    mainImageUrlChange(val) {
      if (val) {
        this.mainImageUrl = URL.createObjectURL(val);
      } else {
        this.mainImageUrl = null;
      }
    },
    onSubmit() {
      this.$emit("tambah", this.form)
    },
    onReset() {
    }
  }
}
</script>
